#!/bin/sh

file="/var/tmp/mgmtdevicetable"

delete()
{
  ip=${1//\./\\.} # back slash dots

  if [ -e $file ]; then
    # delete indicated line
    sed -i /$ip/d $file
  fi
}

if [ $# -eq 5  ]; then
  # check variable length
  if [ ${#1} -gt 15 ]; then
     echo "ip addr too long";
     exit 0;
  elif [ ${#2} -ne 17 ]; then
     echo "mac addr incorrect length"
     exit 0
  elif [ ${#3} -ne 6 ]; then
     echo "oui too long";
     exit 0;
  fi

  sn=$4
  if [ ${#sn} -gt 64 ]; then
     # truncate
     sn=${sn:0:64}
  fi

  pc=$5
  if [ ${#pc} -gt 64 ]; then
     # truncate
     pc=${pc:0:64}
  fi

  # always assume we have new device and new data
  # so delete old data if it exists
  delete $1

  # write data to file if less than 64 entries
  if [ ! -e $file ]; then
     echo "$1|$2|$3|$sn|$pc" >> $file
  else
     if [ `wc -l $file | cut -d" " -f1` -lt 64 ]; then
       echo "$1|$2|$3|$sn|$pc" >> $file
     fi
  fi

elif [ $# -eq 1 ]; then
  if [ $1 != "" ] && [ ${#1} -gt 15 ]; then
     echo "ip addr invalid";
     exit 0;
  fi

  delete $1

else
     echo "incorrect args";
     exit 0;
fi
