-- this file hold utility functions that support
-- operations on mounted file systems.
module(..., package.seeall);

require "functions"

-- execute system command
-- how to check for an error?
-- return a blob
function system(command)
   local f = io.popen(command)
   local out = f:read("*a")
   f:close()
   return out
end

function mangle_dir(dir)
  -- this needs to be a global search and replace to escape spaces
  SESS.SESS_MANGLED_WORKING_DIR = string.gsub(dir, " ", "\\ ")
end

function child_directory(child)
  SESS.SESS_WORKING_DIR = string.format("%s/%s", SESS.SESS_WORKING_DIR, child)
  mangle_dir(SESS.SESS_WORKING_DIR)
end

function parent_directory(chldDir)
  -- chop off anything after the last trailing '/' to find our parent directory
  _, _, SESS.SESS_WORKING_DIR = string.find(chldDir, "^(.+)/[%w%p%s\]+$")
  mangle_dir(SESS.SESS_WORKING_DIR)
end

function create_directory(newdir)
  out = system(string.format("mkdir %s 2>&1", newdir))
  -- FIX. need some error handler, of some kind
  --err = os.execute("echo -n $?")
  --if err ~= "0" then
    --out = os.execute(string.format("echo -n %s | sed -e s#%s/##"), out, SESS.SESS_WORKING_DIR)
	--SESS.SESS_error_message = out
  --end
end

function display_parent()
  print(string.format("<tr><td><input class=\"buttonuparrow\" type=\"submit\" name=\"ParentDir\" value=\"%s\" /></td>",SESS.SESS_WORKING_DIR))
  print("<td>Parent Directory</td></tr>")
end

function display_contents()
   if SESS.SESS_WORKING_DIR == nil then
     return;
   end
   dirlist = system(string.format("ls -lL \"%s\"", SESS.SESS_WORKING_DIR))

--  print(string.format("ls -lL \"%s\"", SESS.SESS_WORKING_DIR))
--  print("<br/>")
--  for line in string.gmatch(dirlist, "([^\n]+)\n") do
--        print(string.format("%s<br/>",line))
--  end

   --err = os.execute("echo -n $?")
   --if err ~= "0" then
      if dirlist == '' then
        display_parent()
        print("<tr><td></td><td>No files to display</td></tr>")
      else
        --os.execute(string.format("echo \"%s\" | grep ^d | display_dirs", dirlist))
        display_dirs(dirlist, true)
        --os.execute(string.format("echo \"%s\" | grep -v ^d | display_files", dirlist))
        display_files(dirlist, true)
      end
   --else
   --   err_msg = dirlist
   --    parent_directory()
   --end
end

function display_dirs(list, addDeleteIcon)
  if SESS.SESS_WORKING_DIR ~= SESS.SESS_CIFS_ROOTDIR then
     display_parent()
  end

   -- Build directories table. ls command assures alphabetical order
  local dirs = {}
  for line in string.gmatch(list, "([^\n]+)\n") do
      if string.match(line, "^d") then
          table.insert(dirs, line)
      end
  end

  for i, line in ipairs(dirs) do
       _, _, fname = string.find(line,
                                 --  1      2     3     4     5     6         7
                                 "^[-%a]+%s+%w+%s+%w+%s+%w+%s+%w+%s+[%p%w]+%s+(.*)$")
       --  find the 4-6 fields               1       2     3     4    5     6    7     8
       _, _, fdate = string.find(line,
                                 -- 1       2     3      4     5       6
                                 "^[-%a]+%s+%w+%s+%w+%s+(%w+%s+%w+%s+[%p%w]+)%s+")
      print(string.format("<tr><td class=\"col2\"><input  class=\"buttondirectory\" type=\"submit\" name=\"ChildDir\" value=\"%s\" /></td>", fname))
      print(string.format("<td class=\"col2\">%s</td>", fname))
      print(string.format("<td class=\"col2\">&nbsp;</td><td align=\"right\">%s</td>", fdate))
      if (addDeleteIcon) then
          print(string.format("<td class=\"col2\" align=\"center\"><input class=\"buttonremove\" type=\"submit\" name=\"RemoveFile\" value=\"%s\" /></td></tr>", fname))
          -- to get popup working, u need to passback document.forms[1].RemoveFile.value or index it
          -- print(string.format("<td class=\"col2\" align=\"center\"><input class=\"buttonremove\" type=\"submit\" name=\"RemoveFile\" value=\"%s\" onclick=\"document.forms[1].hiddenConfirmAction.value = confirm(document.forms[1].hiddenConfirmQstn.value); this.form.submit();\" /></td></tr>", fname))
      else
          print(string.format("</tr>"))
      end
  end
end

function display_files(list, addDeleteIcon)
  print(string.format("<tr><td><input type=\"hidden\" name=\"DownloadPath\" value=\"%s\" /></td></tr>", SESS.SESS_WORKING_DIR))
  local files = {}
  for line in string.gmatch(list, "([^\n]+)\n") do
      if not string.match(line, "^d") then
          table.insert(files, line)
      end
  end

  for i, line in ipairs(files) do
       --  1         2 3   4   5  6     7
       -- -rw-r--r-- 1 848 Jul 16 15:48 cifs_build_notes
       _, _, fname = string.find(line,
                                 -- 1        2     3     4     5     6         7
								 "^[-%a]+%s+%w+%s+%w+%s+%w+%s+%w+%s+[%p%w]+%s+(.*)$")
       --  find the file size, 3rd field
	   _, _, fsize = string.find(line,
                                 -- 1       2     3      4     5
                                 "^[-%a]+%s+%w+%s+(%w+)%s+%w+%s+%w+%s+")
       --  find the file date, 4-to-6 fields
       _, _, fdate = string.find(line,
                                 -- 1       2     3      4     5       6
                                 "^[-%a]+%s+%w+%s+%w+%s+(%w+%s+%w+%s+[%p%w]+)%s+")
      print(string.format("<tr><td><input class=\"buttonfile\" type=\"submit\" name=\"DownloadFile\" value=\"%s\" /></td>", fname))
      print(string.format("<td>%s</td>", fname))
      print(string.format("<td align=\"right\">%s</td><td align=\"right\">%s</td>", fsize, fdate))
      if (addDeleteIcon) then
          print(string.format("<td class=\"col2\" align=\"center\"><input class=\"buttonremove\" type=\"submit\" name=\"RemoveFile\" value=\"%s\" /></td></tr>", fname))
          -- to get popup working, u need to passback document.forms[1].RemoveFile.value or index it
          -- print(string.format("<td class=\"col2\" align=\"center\"><input class=\"buttonremove\" type=\"submit\" name=\"RemoveFile\" value=\"%s\" onclick=\"document.forms[1].hiddenConfirmAction.value = confirm(document.forms[1].hiddenConfirmQstn.value); this.form.submit();\" /></td></tr>", fname))
      else
          print(string.format("</tr>"))
      end
  end
end

function unmount_share()
   sdb.run("cifs-share.umount")
   SESS.SESS_ismounted = 0
   SESS.SESS_CIFS_ROOTDIR = ""
   SESS.SESS_WORKING_DIR = ""
   SESS.SESS_MANGLED_WORKING_DIR = ""
   SESS.SESS_ServerIP = ""
   SESS.SESS_Share_Name = ""
   SESS.SESS_Username = ""
   SESS.SESS_Password = ""
   SESS.SESS_state = "init"
  SESS.SESS_state = "unmount!"
   SESS.SESS_hidden = ""
end

function mount_share()
  -- block user from mounting while we are waiting
  if SESS.SESS_state ~= "wait" then
    sdb.run("cifs-share.mount", SESS.SESS_ServerIP, SESS.SESS_Share_Name, SESS.SESS_Username, SESS.SESS_Password)
    -- wait and refresh until mount either succeeds or fails
    SESS.SESS_state = "wait"
  end
end

function mount_share_guest()
  username = "guest"
  password = ""

  -- block user from mounting while we are waiting
  if SESS.SESS_state ~= "wait" then
    sdb.run("mountcifs", SESS.SESS_ServerIP, SESS.SESS_Share_Name, username, password)
    -- wait and refresh until mount either succeeds or fails
    SESS.SESS_state = "wait"
  end
end

function ask_for_username_password(server, name)
   if server == nil or name == nil then
      return
    end
    print("<tr><td><table>")
    print(string.format("<tr><td>Server: </td><td align=\"center\">%s</td></tr>", server))
    print(string.format("<tr><td>Share name: </td><td align=\"center\">%s</td></tr>", name))
    print("</table></td></tr>")
    print("<tr><td>&nbsp;<br /></td></tr>")
    print("<tr><td>")
    print("username<input type=\"text\" name=\"Username\" /><br />")
    print("password<input type=\"password\" name=\"Password\" />")
    print("</td></tr>")
    print("<tr><td>&nbsp;<br /></td></tr>")
    print("<tr><td>")
    print("<input class=\"buttonclass\" type=\"submit\"")
    print(" value=\"_{{Mount}}\" name=\"Mount\" />")
    print("</td></tr>")
end

-- smbclient -L 192.168.0.52 -N
-- args: ip username password
function list_shares(ip, username, password)
   -- must have at least ip defined
   if ip == nil or ip == "" then
      return
    end
  if username ~= nil and username ~= "" then
    -- username password login
    -- FIX: should check that we have a password
    s = string.format("smbclient -L %s --user=%s //%s/ %s 2>&1", ip, username, ip, password)
  else
    -- anonymous login
    s = string.format("smbclient -L %s -N 2>&1", ip)
  end

  -- look for disk slice to display
  shares = system(string.format("%s",s))
  for l in string.gmatch(shares, "([^\n]+)\n") do
    -- find disk slice
    _, _, sname = string.find(l, "(%w+)%s+Disk")
	if  sname ~= nil then
       share_name = sname
       -- use server button for now, just to get this working.
       -- should be something that looks like a folder
       print("<tr>")
       print(string.format("<td><input class=\"buttonserver\" type=\"submit\" name=\"Share_Name\" value=\"%s\" /></td>", share_name))
       print(string.format("<td>%s</td>", ip))
       print(string.format("<td>%s</td>", share_name))
       print("</tr>")
    end
    --FIXd="$(echo ${l} | grep NT_STATUS_ACCESS_DENIED)"
    --FIXif [ "${d}" != "" then
      denied = 1
      --FIXbreak;
    --end
  end
  if denied == "1" then
    print("<td>access denied</td>")
    print("<tr><td>")
    print("<p>Access denied. Enter username and password:</p>")
    print("username <input type\"text\" name=\"Username\" /><br />")
    print("password <input type=\"password\" name=\"Password\" />")
    print("</td>")
    print("<td>")
    print("<input class=\"buttonclass\" type=\"submit\"")
    print(" value=\"_{{Login}}\" name=\"Login\" />")
    print("</td>")
    print("</tr>")
  elseif share_name == "" then
       print("<p>No disk shares found with anonymous login</p>")
       print("<p>retry with username and password</p>")
       print("<tr><td>")
       print("username <input type\"text\" name=\"Username\" /><br />")
       print("password <input type=\"password\" name=\"Password\" />")
       print("</td></tr>")
       print("<tr><td>")
       print("<tr><td>")
       print("<input class=\"buttonclass\" type=\"submit\"")
       print(" value=\"_{{Retry List Shares}}\" name=\"Retry_List_Shares\" />")
       print("</td>")
       print("</tr>")
  --end
  end
end

-- smbclient -L XKQP43-03 -I 192.168.0.1 -N
function client()
  --FIXc="$(smbclient -L ${1} -I ${2} -N 2>&1)"
end

function lookup(ip_addr)
  cmd = string.format("nmblookup -A %s -N 2>&1", ip_addr)
  n = system(cmd)

  print(string.format("<tr><td><input class=\"buttonserver\" type=\"submit\" name=\"ServerIP\" value=\"%s\" /></td>", ip_addr))
  print(string.format("<td>%s</td>", ip_addr))

  for l in string.gmatch(n, "([^\n]+)\n") do
    local service_name = ""
    local group_name = ""
    _, _, service_name = string.find(l, "(%w+)%s+\<00\>")
	if service_name ~= nil and service_name ~= "" and string.match(l,"\<GROUP\>") == nil then
       print(string.format("<td>%s</td>", service_name))
       -- do more here if we want to display information about the server
       -- client ${service_name} ${1}
    end

    _, _, group_name = string.find(l, "(%w+)%s+\<00\>.*\<GROUP\>")
	if group_name ~= nil and group_name ~= "" then
       print(string.format("<td>%s</td>", group_name, l))
    end
  end

  print("</tr>")
end

function get_local_servers()
  -- may need to add "-B <broadcast address"
  -- to tie this down to a specific interface
  servers = system("nmblookup '*' 2>&1")
  -- get list of IP addresses
  for l in string.gmatch(servers, "([^\n]+)\n") do
    if string.match(l, "<00>") then
	  -- find ip_addr *<00>
     _, _, ip = string.find(l, "(%d+\.%d+\.%d+\.%d+)%s+\*<00>")
     lookup(ip)
    end
  end
end

-- usage: download_file <path> <name>
function download_file(path, filename)
  -- Fix! need some error checking here:
  --  path and file args exist
  --  check that file exists
  cmd = string.format("ls -l \"%s/%s\"", path, filename)
  line = system(cmd)
  _, _, filelen = string.find(line,
                               -- 1       2     3      4     5
                              "^[-%a]+%s+%w+%s+(%w+)%s+%w+%s+%w+%s+")

  -- use io.write here to control \r\n line endings
  io.write("Pragma: no-cache\r\n")
  io.write("Content-Type: Application/Octet-stream\r\n")
  io.write(string.format("Content-Length: %s", filelen), "\r\n")
  io.write(string.format("Content-disposition: attachment;filename=%s", filename), "\r\n\r\n")

  -- spew out the file...
  local f = io.open(string.format("%s/%s", path, filename), "rb")
  while true do
    local block = f:read(4096)
    if not block then break end
    io.write(block) -- write to stdout
  end
  f:close()
end
